# 19 - AddressableLED

## Are you telling me I can make my robot RGB?
Yes, you can! (with some caveats). 

LEDs in FRC should be used tastefully, the LEDs you use should either serve a purpose (like those on the Limelight camera) or be discrete enough that they aren't painful to look at while you're on the playing field. 

You're limited to using LEDs from the WS2812 family or similar (most consumers are familar with this type of LED under the name Adafruit NeoPixel). You CANNOT use APA102s (again, more commonly known as Adafruit DotStars) with the libraries shown in this example. With that being said, theoretically, you could use APA102s with the RoboRIO, but it would require extra development effort on your part, again, at least at the time of writing. 

You do have a limit on the number of LEDs you can run, it's something like 5700 LEDs though, so that shouldn't be a problem. However, you can only use one continuous strip of LEDs on the RoboRIO at a time, if you want to have separate strips on your robot doing different things, you'll need to make long wire runs and separate the different sections of the singular strip logically, rather than physically. This is easy enough to do, but will require more than just beginner level programming experience if you want to get too complicated. 

## When can I start installing the LEDs? Moar RGB moar better. 
If your LEDs are going to serve a purpose, like indicating when a shooter wheel is fully spun up or provide extra light for vision tracking, then set those up at the same time you're implementing code for that system. Your drive team will need the opportunity to get used to using the LEDs as reference. 

If you're just using LEDs for looks, like underglow or flame animation, it should wait towards the end (if not the very end) of robot construction. LEDs for looks should be an after thought that comes later, and shouldn't ever obstruct getting work done on real mechanisms that are designed to complete game objectives. 